package ru.indvdum.mywork;

import java.util.Date;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.mortbay.component.LifeCycle;
import org.mortbay.component.LifeCycle.Listener;
import org.mortbay.jetty.Connector;
import org.mortbay.jetty.Server;
import org.mortbay.jetty.servlet.Context;
import org.mortbay.jetty.servlet.ServletHolder;

import com.vaadin.terminal.gwt.server.ApplicationServlet;

/**
 * @author indvdum
 * 12.08.2011 17:31:37
 *
 */
public class MyWork {
	public static EntityManagerFactory EMF = null;
	public static EntityManager EM = null;

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		Server server = new Server();
		Connector connector = new org.mortbay.jetty.nio.SelectChannelConnector();
		connector.setPort(8080);
		connector.setMaxIdleTime(720000);
		server.addConnector(connector);
		
		Context root = new Context(server, "/", Context.SESSIONS);
		ServletHolder vaadinServlet = new ServletHolder(new ApplicationServlet());
		vaadinServlet.setInitParameter("application", "ru.indvdum.mywork.vaadin.MyWorkApplication");
		root.addServlet(vaadinServlet, "/*");
		
		server.addLifeCycleListener(new Listener(){

			@Override
			public void lifeCycleFailure(LifeCycle event, Throwable cause) {
				
			}

			@Override
			public void lifeCycleStarted(LifeCycle event) {
				EMF = Persistence.createEntityManagerFactory("mywork");
				EM = EMF.createEntityManager();
			}

			@Override
			public void lifeCycleStarting(LifeCycle event) {
				
			}

			@Override
			public void lifeCycleStopped(LifeCycle event) {
				
			}

			@Override
			public void lifeCycleStopping(LifeCycle event) {
				EM.close();
				EMF.close();
			}
			
		});
		
		server.start();
		System.out.println("Jetty server started at " + new Date());
	}

}
